"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GlobalExceptionFilter = void 0;
const tslib_1 = require("tslib");
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const api_response_presenter_1 = require("../presentation/api-response.presenter");
const axios_1 = require("axios");
let GlobalExceptionFilter = class GlobalExceptionFilter extends core_1.BaseExceptionFilter {
    constructor() {
        super();
    }
    catch(exception, host) {
        const ctx = host.switchToHttp();
        const response = ctx.getResponse();
        let status = common_1.HttpStatus.BAD_REQUEST;
        const message = [];
        if (exception instanceof common_1.HttpException) {
            status = exception.getStatus();
        }
        if (exception instanceof axios_1.AxiosError && exception.status) {
            status = exception.status;
        }
        if (exception instanceof common_1.BadRequestException) {
            const errResponse = exception.getResponse();
            if (response) {
                if (errResponse.message instanceof Array) {
                    message.push(...errResponse.message);
                }
                else {
                    message.push(errResponse.message);
                }
            }
            message.push();
        }
        else {
            message.push(exception.message);
        }
        response.status(status).json(api_response_presenter_1.ApiResponsePresenter.createException(status, message));
    }
};
exports.GlobalExceptionFilter = GlobalExceptionFilter;
exports.GlobalExceptionFilter = GlobalExceptionFilter = tslib_1.__decorate([
    (0, common_1.Catch)(),
    tslib_1.__metadata("design:paramtypes", [])
], GlobalExceptionFilter);
